--------------------------------------------------------------------------------
-- Carnage Contest AI (Artificial Intelligence) Script
-- Script by DC, February 2010, www.UnrealSoftware.de
--------------------------------------------------------------------------------

ai={}

-- Initialization Function (called once at each start of AI turn)
function ai_init()
	ai.suicide1=0
	ai.suicide2=0
	math.randomseed(os.time())
	ai.dir=0
	players=playertable(3,0)
	ai.bestplayer=0;
	ai.bestx=9999;
	ai.lx=getplayerx(0)
	for i=1,#players,1 do
		if (math.abs(getplayerx(players[i])-ai.lx)<ai.bestx) or (ai.bestplayer==0) then
			ai.bestplayer=players[i]
			ai.bestx=math.abs(getplayerx(players[i])-ai.lx)
		end
	end
	if (getplayerx(ai.bestplayer)-ai.lx)>0 then ai.dir=1 end
	ai.lx=666
end

-- Movement Function (called each frame, pre attack)
function ai_move()
	if (math.abs(getplayerx(ai.bestplayer)-getplayerx(0))<16) and ((getplayery(ai.bestplayer)-getplayery(0))<10) and ((getplayery(ai.bestplayer)-getplayery(0))>(-28)) then
		if (getplayerx(ai.bestplayer)-ai.lx)>0 then ai_right() else ai_left() end
		ai_attack()
	else
		if ai.lx==getplayerx(0) then
			ai_backjump()
			ai.suicide1=ai.suicide1+1
		else
			if (ai.suicide1>0) then ai.suicide1=ai.suicide1-1 end
		end
		if (getplayery(0)>=(getwatery()-55)) then
			ai_jump()
		else
			if ai.dir==0 then
				ai_left()
			else
				ai_right()
			end
		end
	end
	ai.ldir=ai.dir
	ai.lx=getplayerx(0)
	if (getplayerx(ai.bestplayer)-ai.lx)>20 then ai.dir=1
	elseif (getplayerx(ai.bestplayer)-ai.lx)<-20 then ai.dir=0
	end
	if (ai.ldir~=ai.dir) then ai.suicide2=ai.suicide2+1 end
	if (ai.suicide1>20) or (ai.suicide2>5) then
		print("AAAAAAAAAAAARRRRRRGGGGHHHHH!")
		ai_weapon("Explosive Belt")
		ai.bestplayer=0
		ai.suicide1=0
		ai.suicide2=0
	end
end

-- Backing Function (called each frame, post attack)
function ai_back()
--do nothing
end


--------------------------------------------------------------------------------
-- AI Helper Functions
-- Attention: These functions are also used by orig. AI weapon Lua scripts
-- !!! CHECK ALL DEPENDENCIES WHEN CHANGING !!!
--------------------------------------------------------------------------------
